let table;

function preload() {
    table = loadTable( 
      	"https://gist.githubusercontent.com/olga-kondr/1df45e663672f7933588f1a50b0361b6/raw/b1bc3ef6c8075186c5328a4b048b9bd4d8702a20/br_for_all_groups_FL.csv",
        "csv", 
        "header"
    );
}

function setup() {
    createCanvas(800, 500);
    background(250);
}

function draw() {
  noStroke();
  fill(150, 150, 150);
  textSize(16);
  text('Birth Rates per 1000 in Florida from 1988 to 2016.', 230, 20);
  textSize(12);

  counterRows = table.getRowCount();
  let dict = {};
  for (let k = 0; k < counterRows; k++) {
    let val = table.getNum(k, 0);
    if (val in dict) {
      let temp = dict[val];//.push(table.getNum(k, 1));
      temp.push(table.getNum(k, 2));
      dict[val] = temp.sort(function(a, b) {return a - b;});
    }else{
      dict[val] = [table.getNum(k, 2)];
    }
  }

  const keys = Object.keys(dict);
  let lenRes = keys.length;
  
  stroke(color(190, 190, 190));
  let step = 20, temps, x;
  for (let i = 0; i < 7; i++) {
    stroke(color(235, 233, 228));
    line(100, 350-i*50, 750, 350-i*50);
    stroke(color(190, 190, 190));
    fill(150, 150, 150);
    noStroke();
    textAlign(RIGHT);
    text(step*(i+1), 80, 350-50*i);
    textAlign(LEFT);
    text(keys[i], 110+i*40, 430);
    stroke(color(190, 190, 190));
  }
  myStorage = window.localStorage;
  let randVals = [];
  
  if (!myStorage.getItem("salt")) {
    for (let i=0; i<6; i++){
      randVals[i] = random(-5,5);
    }
    myStorage.setItem("salt", randVals);
  } 
  
  randVals = myStorage.getItem("salt");
  
  for (let i=0; i<lenRes; i++) {
    noStroke();
    fill(150, 150, 150);
    text(keys[i], 110+i*40, 430);
    stroke(color(190, 190, 190));
    temps = dict[keys[i]];
    x = 120+i*40;
    temps.forEach((item1, j) => {
      stroke(color(250, 188, 55));
      strokeWeight(7);
      point(x+parseFloat(randVals[j]), 400-item1*50/step);
      strokeWeight(1);
    });
  }
  
  noStroke();
  push();
  let axisy = radians(270);
  translate(20, 180);
  rotate(axisy);
  textSize(16);
  fill(150, 150, 150);
  text('Birth Rate per 1000', -120, 10);
  textSize(12);
  pop();
  
  noStroke();
  textSize(16);
  fill(150, 150, 150);
  text('Year', 360, 470);
  textSize(12);

  stroke(color(0, 0, 0));
  line(100, 400, 100, 45)
  line(100, 400, 750, 400);
  noStroke();
  textAlign(RIGHT);
  text('0', 80, 400);
  textAlign(LEFT);
}
